#!/usr/bin/tclsh

# Main proc at the end #

proc tlmvm_compil { } {

    set currentDir [pwd]

    cd ../tlmvm/comp
    puts -nonewline "Compile TLMVM : "
    do ../scripts/compile.do
    cd $currentDir

    vmap tlmvm ../tlmvm/comp/tlmvm
}

#------------------------------------------------------------------------------
proc vhdl_compil { } {
    global Path_VHDL
    global Path_TB

    # Packages
    vcom -2008 $Path_VHDL/tictactoe_config_pkg.vhd
    vcom -2008 $Path_VHDL/log_pkg.vhd

    # Design Files
    vcom -2008 $Path_VHDL/tictactoe_top.vhd
    # Add subsequent created files here

    # Test Bench Files
    vcom -2008 $Path_TB/tictactoe_tb.vhd
    vcom -2008 $Path_TB/tictactoe_dual_tb.vhd
}

#------------------------------------------------------------------------------
proc sim_start { } {
    global Dual_TB

    if {$Dual_TB == 1} {
        vsim -t 1ns -novopt work.tictactoe_dual_tb
    } else {
        vsim -t 1ns -novopt work.tictactoe_tb
    }

    # Recursively add all waves
    add wave -r *
    # Add specific waves or groups here

    wave refresh
    run -all
}

#------------------------------------------------------------------------------
proc do_all { } {
    tlmvm_compil
    vhdl_compil
    sim_start
}

## MAIN #######################################################################

# Compile folder ----------------------------------------------------
if {[file exists work] == 0} {
    vlib work
}

#tlmvm_compil

#puts -nonewline "  Path_VHDL => "
set Path_VHDL     "../src_vhdl"
set Path_TB       "../src_tb"
set Dual_TB 0

global Path_VHDL
global Path_TB
global Dual_TB





# start of sequence -------------------------------------------------

# Usage : vsim -do "do ../scripts/sim.do [dual] [all|comp_vhdl|sim]"
#
# (optional argument) if dual is specified as first argument launch test bench with two DUTs
# (optional argument) all       : launches everything
#                     comp_vhdl : only compiles the source code
#                     sim       : only simulation


# Note : This is very basic argument handling and could be rewritten
if {$argc>=1} {
    if {[string compare $1 "dual"] == 0} {
        set Dual_TB 1
        if {$argc > 1} {
            if {[string compare $2 "all"] == 0} {
                do_all
            } elseif {[string compare $2 "comp_vhdl"] == 0} {
                vhdl_compil
            } elseif {[string compare $2 "sim"] == 0} {
                sim_start
            }
        } else {
            do_all
        }
    } elseif {[string compare $1 "all"] == 0} {
        do_all
    } elseif {[string compare $1 "comp_vhdl"] == 0} {
        vhdl_compil
    } elseif {[string compare $1 "sim"] == 0} {
        sim_start
    } else {
        do_all
    }
} else {
    do_all
}
