------------------------------------------------------------------------------------------
-- HEIG-VD ///////////////////////////////////////////////////////////////////////////////
-- Haute Ecole d'Ingenerie et de Gestion du Canton de Vaud
-- School of Business and Engineering in Canton de Vaud
------------------------------------------------------------------------------------------
-- REDS Institute ////////////////////////////////////////////////////////////////////////
-- Reconfigurable Embedded Digital Systems
------------------------------------------------------------------------------------------
--
-- File                 : tictactoe_top.vhd
-- Author               : 
-- Date                 : 12.04.2017
--
-- Context              : Tic-Tac-Toe game
--
------------------------------------------------------------------------------------------
-- Description : Top file for the Tic-Tac-Toe game
--   
------------------------------------------------------------------------------------------
-- Dependencies : tictactoe_config_pkg.vhd
--                log_pkg.vhd
--   
------------------------------------------------------------------------------------------
-- Modifications :
-- Ver    Date        Engineer      Comments
-- 0.0    See header  FCC           Initial version.
--
------------------------------------------------------------------------------------------

use work.tictactoe_config_pkg.all;
use work.log_pkg.all;

library ieee ;
    use ieee.std_logic_1164.all ;
    use ieee.numeric_std.all ;

entity tictactoe_top is
  port (
    clk_i           : in  std_logic; -- 27Mhz
    rst_i           : in  std_logic; -- KEY3
    -- Game controls
    keys_i          : in  std_logic_vector( 2 downto 0);
    switchs_i       : in  std_logic_vector( 7 downto 0);
    -- Game state
    game_state_o    : out game_state_t;
    -- Master interface
    master_en_i     : in  std_logic;
    sclk_o          : out std_logic;
    mosi_o          : out std_logic;
    miso_i          : in  std_logic;
    n_ss_o          : out std_logic;
    -- Slave interface
    sclk_i          : in  std_logic;
    mosi_i          : in  std_logic;
    miso_o          : out std_logic;
    n_ss_i          : in  std_logic
  );
end entity; -- tictactoe_top

architecture replace_me of tictactoe_top is

    -- SPI
    constant SPI_LENGTH      : integer := 8;
    constant CLK_DIV         : integer := CLK_FREQ;-- freq SCLK = 27MHz/27 = 1Mhz

begin

end architecture ;
